// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"path/filepath"
	"testing"

	"github.com/google/go-cmp/cmp"
	"github.com/google/go-cmp/cmp/cmpopts"
	"github.com/stretchr/testify/require"
	"go.opentelemetry.io/collector/confmap/confmaptest"
)

func TestMetricsBuilderConfig(t *testing.T) {
	tests := []struct {
		name string
		want MetricsBuilderConfig
	}{
		{
			name: "default",
			want: DefaultMetricsBuilderConfig(),
		},
		{
			name: "all_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					GitRepositoryBranchCommitAheadbyCount:  MetricConfig{Enabled: true},
					GitRepositoryBranchCommitBehindbyCount: MetricConfig{Enabled: true},
					GitRepositoryBranchCount:               MetricConfig{Enabled: true},
					GitRepositoryBranchLineAdditionCount:   MetricConfig{Enabled: true},
					GitRepositoryBranchLineDeletionCount:   MetricConfig{Enabled: true},
					GitRepositoryBranchTime:                MetricConfig{Enabled: true},
					GitRepositoryContributorCount:          MetricConfig{Enabled: true},
					GitRepositoryCount:                     MetricConfig{Enabled: true},
					GitRepositoryPullRequestCount:          MetricConfig{Enabled: true},
					GitRepositoryPullRequestTimeOpen:       MetricConfig{Enabled: true},
					GitRepositoryPullRequestTimeToApproval: MetricConfig{Enabled: true},
					GitRepositoryPullRequestTimeToMerge:    MetricConfig{Enabled: true},
				},
				ResourceAttributes: ResourceAttributesConfig{
					GitVendorName:    ResourceAttributeConfig{Enabled: true},
					OrganizationName: ResourceAttributeConfig{Enabled: true},
				},
			},
		},
		{
			name: "none_set",
			want: MetricsBuilderConfig{
				Metrics: MetricsConfig{
					GitRepositoryBranchCommitAheadbyCount:  MetricConfig{Enabled: false},
					GitRepositoryBranchCommitBehindbyCount: MetricConfig{Enabled: false},
					GitRepositoryBranchCount:               MetricConfig{Enabled: false},
					GitRepositoryBranchLineAdditionCount:   MetricConfig{Enabled: false},
					GitRepositoryBranchLineDeletionCount:   MetricConfig{Enabled: false},
					GitRepositoryBranchTime:                MetricConfig{Enabled: false},
					GitRepositoryContributorCount:          MetricConfig{Enabled: false},
					GitRepositoryCount:                     MetricConfig{Enabled: false},
					GitRepositoryPullRequestCount:          MetricConfig{Enabled: false},
					GitRepositoryPullRequestTimeOpen:       MetricConfig{Enabled: false},
					GitRepositoryPullRequestTimeToApproval: MetricConfig{Enabled: false},
					GitRepositoryPullRequestTimeToMerge:    MetricConfig{Enabled: false},
				},
				ResourceAttributes: ResourceAttributesConfig{
					GitVendorName:    ResourceAttributeConfig{Enabled: false},
					OrganizationName: ResourceAttributeConfig{Enabled: false},
				},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadMetricsBuilderConfig(t, tt.name)
			if diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(MetricConfig{}, ResourceAttributeConfig{})); diff != "" {
				t.Errorf("Config mismatch (-expected +actual):\n%s", diff)
			}
		})
	}
}

func loadMetricsBuilderConfig(t *testing.T, name string) MetricsBuilderConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	cfg := DefaultMetricsBuilderConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}

func TestResourceAttributesConfig(t *testing.T) {
	tests := []struct {
		name string
		want ResourceAttributesConfig
	}{
		{
			name: "default",
			want: DefaultResourceAttributesConfig(),
		},
		{
			name: "all_set",
			want: ResourceAttributesConfig{
				GitVendorName:    ResourceAttributeConfig{Enabled: true},
				OrganizationName: ResourceAttributeConfig{Enabled: true},
			},
		},
		{
			name: "none_set",
			want: ResourceAttributesConfig{
				GitVendorName:    ResourceAttributeConfig{Enabled: false},
				OrganizationName: ResourceAttributeConfig{Enabled: false},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			cfg := loadResourceAttributesConfig(t, tt.name)
			if diff := cmp.Diff(tt.want, cfg, cmpopts.IgnoreUnexported(ResourceAttributeConfig{})); diff != "" {
				t.Errorf("Config mismatch (-expected +actual):\n%s", diff)
			}
		})
	}
}

func loadResourceAttributesConfig(t *testing.T, name string) ResourceAttributesConfig {
	cm, err := confmaptest.LoadConf(filepath.Join("testdata", "config.yaml"))
	require.NoError(t, err)
	sub, err := cm.Sub(name)
	require.NoError(t, err)
	sub, err = sub.Sub("resource_attributes")
	require.NoError(t, err)
	cfg := DefaultResourceAttributesConfig()
	require.NoError(t, sub.Unmarshal(&cfg))
	return cfg
}
